
/*
 *  Copyright (C) 1999  Wolfgang Zekoll  <wzk@quietsche-entchen.de.de>
 *
 *  This software is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


#include <stdlib.h>
#include <string.h>

#include <ctype.h>
#include <time.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <errno.h>

#include "strlib.h"


int close_fd(int fd)
{
	return (close(fd));
}

int open_fd(char *filename)
{
	int	fd;

	if ((fd = open(filename, O_RDONLY)) < 0) {
		fprint (2, "can't open file: %s\n", filename);
		return (-1);
		}

	return (fd);
}

int getc_fd(int fd)
{
	int	rc, c, m;

	m = 1;
	if ((rc = read(fd, &c, m)) <= 0)
		return (-1);
	
	c = c & 0xFF;
	return (c);
}

char *readline_fd(int fd)
{
	int	c, i, k;
	static int linesize = 0;
	static char *line = NULL;

	if (line == NULL)
		line = realloc(line, (linesize = 2048));

	c = getc_fd(fd);
	if (c < 0)
		return (NULL);

	k = 0;
	while (c > 0  &&  c != '\n'  &&  c != 0) {
		if (k >= linesize)
			line = realloc(line, (linesize += 2048));

		line[k++] = c;
		c = getc_fd(fd);
		}

	line[k] = 0;
	for (i=k-1; i>=0; i--) {		/* remove white space at the end */
		if ((c = line[i]) != 0  &&  c <= ' ')
			line[i] = 0;
		else
			break;
		}
		
	return (line);
}

